<?php
    /*
     *      OSCLass – software for creating and publishing online classified
     *                           advertising platforms
     *
     *                        Copyright (C) 2010 OSCLASS
     *
     *       This program is free software: you can redistribute it and/or
     *     modify it under the terms of the GNU Affero General Public License
     *     as published by the Free Software Foundation, either version 3 of
     *            the License, or (at your option) any later version.
     *
     *     This program is distributed in the hope that it will be useful, but
     *         WITHOUT ANY WARRANTY; without even the implied warranty of
     *        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     *             GNU Affero General Public License for more details.
     *
     *      You should have received a copy of the GNU Affero General Public
     * License along with this program.  If not, see <http://www.gnu.org/licenses/>.
     */

    class bitpay
    {

        public function __construct()
        {
        }

        /**
        * Create and print a "Pay with Paypal" button
        *
        * @param float $amount
        * @param string $description
        * @param string $itemnumber (publish fee, premium, pack and which category)
        * @param string $extra custom variables
        */
        public static function button($amount = '0.00', $description = '', $itemnumber = '101', $extra_array = null) {
            $extra = payment_prepare_custom($extra_array);
            $extra .= 'concept,'.$description.'|';
            $extra .= 'product,'.$itemnumber.'|';
            $extra .= 'amount,'.$amount.'|';
            $r = rand(0,1000);
            $extra .= 'random,'.$r;
            echo '<li class="payment bitpay-btn">';
            //if(osc_get_preference('bitpay_enable', 'peyment')==1) {

            $action = payment_url().'payments/bitpay/send.php';
        ?>
            <form action="<?php echo $action; ?>" method="post" id="bitpay_<?php echo $r; ?>">
              <input type="hidden" name="amount" value="<?php echo $amount; ?>" />
              <input type="hidden" name="custom" value="<?php echo $extra; ?>" />
            </form>
            <div class="buttons">
              <div class="right"><a id="button-confirm" class="button" onclick="$('#bitpay_<?php echo $r; ?>').submit();"><span><img src='<?php echo payment_url(); ?>payments/bitpay/images/bitpaybtn.png' border='0' /></span></a></div>
            </div>
        <?php
       // }

            echo '</li>';
        }


        public static function send($url,$api,$amount,$redirect){
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"$url");
            curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
            $res = curl_exec($ch);
            curl_close($ch);
            return $res;
        }
        public static function get($url,$api,$trans_id,$id_get){
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"$url");
            curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
            $res = curl_exec($ch);
            curl_close($ch);
            return $res;
        }

    }
?>